﻿using System;
using System.Collections.ObjectModel;
using Xamarin.Forms;

namespace Agtrix.MapSuitForms
{
    public class FormsViewMap : View
    {
        private Collection<FormsOverlay> overlays;

        public FormsViewMap()
            : base()
        {
            overlays = new Collection<FormsOverlay>();
        }
        public static readonly BindableProperty GPSTimeProperty =
           BindableProperty.Create<FormsViewMap, TimeSpan>(
               p => p.GPSTime, default(TimeSpan));
        public TimeSpan GPSTime
        {
            get { return (TimeSpan)GetValue(GPSTimeProperty); }
            set { SetValue(GPSTimeProperty, value); }
        }
        
        public static readonly BindableProperty IsTrackingProperty =
           BindableProperty.Create<FormsViewMap, bool>(
               p => p.IsTracking, default(bool));
        public bool IsTracking
        {
            get { return (bool)GetValue(IsTrackingProperty); }
            set { SetValue(IsTrackingProperty, value); }
        }
        public static readonly BindableProperty IsRecordingProperty =
           BindableProperty.Create<FormsViewMap, bool>(
               p => p.IsRecording, default(bool));
        public bool IsRecording
        {
            get { return (bool)GetValue(IsRecordingProperty); }
            set { SetValue(IsRecordingProperty, value); }
        }

        public void NotifyLayerChanged(string layer)
        {
            if (LayerChanged != null)
                LayerChanged(this, layer);
        }

        public event EventHandler<string> LayerChanged;
        public void NotifySelectionChanged(Xamarin.Forms.Point newLocatoion)
        {
            if (SelectionChanged != null)
                SelectionChanged(this, newLocatoion);
        }

        public event EventHandler<Xamarin.Forms.Point> SelectionChanged;

        public void NotifyLocationChange(Xamarin.Forms.Point newLocatoion)
        {
            if (LocationChanged != null)
                LocationChanged(this, newLocatoion);
        }

        public event EventHandler<Xamarin.Forms.Point> LocationChanged;
        //public RectangleShape CurrentExtent
        //{
        //    get { return currentExtent; }
        //    set { currentExtent = value; }
        //}

        public Collection<FormsOverlay> Overlays
        {
            get { return overlays; }
        }
    }
}